#pragma once

#include <Writer.h>
#include <Vec3.h>

class Chunk;
class Block;
class Entity;

class NetworkResponse
{
private:
    char *adress;
    char adressLength;
    Framework::Vec3<float> minPosition;
    Framework::Vec3<float> maxPosition;
    bool broadcast;
    char *message;
    bool msgDelete;
    int msgLength;

public:
    NetworkResponse();
    ~NetworkResponse();

    void adressChunck( Chunk *zChunk );
    void adressEntity( Entity *zEntity );
    void adressBlock( Block *zBlock );
    void setMessage( char *msg, int length, bool deleteMsg );
    void sendToAll();

    bool isAreaAffected( Framework::Vec3<float> min, Framework::Vec3<float> max ) const;
    void writeTo( Framework::StreamWriter *zWriter ) const;
    bool isBroadcast() const;
};