#pragma once

#include <Array.h>

#include "TickWorker.h"

class TickOrganizer : public virtual Framework::ReferenceCounter
{
private:
    int workerCount;
    TickWorker **workers;
    Framework::Array<Block *> tickSources;
    TickQueue *queue;

public:
    TickOrganizer();
    ~TickOrganizer();

    void nextTick();

    void addTickSource( Block *zBlock );
    void removeTickSource( Block *zBlock );
};