#pragma once

#include <Vec3.h>

struct Area
{
    int startX;
    int startY;
    int endX;
    int endY;
    int dimensionId;
};

enum Direction
{
    NO_DIRECTION = 0,
    NORTH = 1,
    EAST = 2,
    SOUTH = 4,
    WEST = 8,
    TOP = 16,
    BOTTOM = 32
};
typedef int Directions;

Direction opposite( Direction dir );
Directions getDirections( Framework::Vec3<float> currentPos, Framework::Vec3<float> otherPos );
Framework::Vec3<int> getDirection( Directions dir );