#include "StaticRegistry.h"
#include "BlockType.h"
#include "ItemType.h"

int count_DimensionGenerator = 0;
int count_ItemType = 0;
int count_BlockType = 0;
int count_WorldUpdateType = 0;
int count_EntityType = 0;

#undef REGISTER
#define REGISTER(c, typ)               \
const int c::ID = count_##typ++;       \
const c *c::INSTANCE = new c(); 

#include "BasicBlocks.h"
#include "OverworldDimension.h"
#include "AddChunkUpdate.h"
#include "Player.h"