#pragma once

#include <Thread.h>
#include <HashMap.h>

#include "Area.h"

class Game;

class WorldLoader : public Framework::Thread
{
private:
    CriticalSection cs;
    Framework::Array<Area> requestQueue;
    Game *zGame;
    bool exit;

public:
    WorldLoader( Game *zGame );
    ~WorldLoader();
    void thread() override;
    void requestLoading( Area request );
    void exitAndWait();
    bool existsChunk( int x, int y, int dimension ) const;
};